/**************************************************************************
 *     Ԃ̍Uh-3D  ` Offense and defense in forts `
 *
 *  03T5025H 약q
 
PDRpC@ 
  gcc toride.c -lglut32 -lglu32 -lopengl32

QDgp@
	̑OɗsQ[3DŁD

@@[
	݂ɁCCeCɔevC[D
	CCRȂǂlāCC̊pxȂC
	^C~O悭L[KpD
	܂CƊpxɂẮCł\D
	
	͉ʉEɖ̒ƌŕ\܂D

@@L[
	㉺EL[@@tB[h]
	Xy[X@@@@
	PageUp@@@@@Y[C
	PageDown@@@@Y[AEg
	a@ɕsړ
	d@Eɕsړ
	s@ɕsړ
	w@ɕsړ
	q@I

	(SHIFTȂ獶EL[ŖC]ł邪C
	@ΐ푊͕Kʂɂ̂ŕKvȂ)

Es@
./a.exe bitmap.bmp  (cygwin̏ꍇ)

IvV64x64̃TCYMS-Windows̃rbg}bvnƁC
n`f[^쐬D
ȗꍇ́CJgfBNgfield01.bmp`field04.bmpgD

RD@\
	CeŎRgl@łD

SDASY
	n`f[^̕\̂߂ɔ؂gC悭`ⓖ蔻肪
	o悤ɂD
	؂瓾ꂽ̂̏Ŵ܂ܕ\ƕsRɌD
	̂߁C@⊮C炵悤ɂD

 **************************************************************************/
 
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <time.h>
#include <GL/gl.h>
#include <GL/glut.h>


#define ELEMENT_SIZE 0.125f
#define TREE_DEPTH 6 //8
#define FIELD_SIZE (1<<TREE_DEPTH)
#define SIZE (FIELD_SIZE*ELEMENT_SIZE)

#define TEXTURES 3
#define TEXSIZE 256
#define MV 0.1
#define PLAYERS 2
#define FIELDS 4

////////////////////////////////////////////////////////////////////////////

// 
// ̗̂NULLDl܂Ă闧̂FULLɓAhX
typedef struct _OTREE{
	struct _OTREE *c[8];
	//int rgb[3];
} OTREE;
OTREE FTREE;
#define FULL (&FTREE)  // l܂Ă闧̂̃AhX

// ʒuƃxNg
typedef struct {
	// zƂĊ֐ɓn߂̋p
	union {
		struct {float x,y,z;};
		float v[3];
	};
} POSITION,VECTOR;

// |S
typedef struct {
	int vert_num;
	int *vertex;
	union {
		VECTOR normal;
		float normal_v[3];
	};
} POLYGON;

// IuWFNg
typedef struct{
	int type;       // IuWFNg̎
	int shade;      // VF[fBO
	int vert_num;   // _
	int poly_num;   // p`
	float color[3]; // F
	POSITION *vert; // _
	union {
		void *data;
		OTREE *octree;  // p`
		POLYGON *poly;  // p`
	};
	VECTOR *normal; // @
} OBJECT;

// IuWFNg̎(͖gp̂̑)
#define OBJECT_NULL     0x0000
#define OBJECT_SPHERE   0x0001
#define OBJECT_RIBON    0x0002
#define OBJECT_SQUARES  0x0003
#define OBJECT_LATHE    0x0004
#define OBJECT_OCTREE   0x0005
#define OBJECT_USER     0x0010

/*============================ {NZfp =============================*/

// Wf[^Octree쐬
OTREE *ot_make(int x,int y,int z,int sz,unsigned char *f)
{
	OTREE tmp,*t;
	int n,m,i;
	if (sz==1) {
		return (f[z*FIELD_SIZE+x]>(y<<(8-TREE_DEPTH)))?FULL:NULL;
	}

	sz=sz>>1;
	tmp.c[0]=ot_make(x   ,y   ,z   ,sz,f);
	tmp.c[1]=ot_make(x+sz,y   ,z   ,sz,f);
	tmp.c[2]=ot_make(x   ,y+sz,z   ,sz,f);
	tmp.c[3]=ot_make(x+sz,y+sz,z   ,sz,f);
	tmp.c[4]=ot_make(x   ,y   ,z+sz,sz,f);
	tmp.c[5]=ot_make(x+sz,y   ,z+sz,sz,f);
	tmp.c[6]=ot_make(x   ,y+sz,z+sz,sz,f);
	tmp.c[7]=ot_make(x+sz,y+sz,z+sz,sz,f);

	n=0;
	m=0;
	for (i=0;i<8;i++) {
		if (tmp.c[i]==NULL) n++;
		if (tmp.c[i]==FULL) m++;
	}
	if (n==8) {
		return NULL;
	} else if (m==8) {
		return FULL;
	}
	t = (OTREE*)malloc(sizeof(OTREE));
	*t=tmp;
	return t;
}

// c[̃J
OTREE *ot_free(OTREE *t) {
	int i;
	for (i=0;i<8;i++)
		if (t->c[i]!=NULL && t->c[i]!=FULL) ot_free(t->c[i]);
	free(t);
	return NULL;
}

// c[œKȏԂɕۂ
OTREE *ot_opt(OTREE *t)
{
	if (t==NULL || t==FULL) return t;
	int n,m,i;

	for (i=0;i<8;i++)
		t->c[i]=ot_opt(t->c[i]);

	n=0;
	m=0;
	for (i=0;i<8;i++) {
		if (t->c[i]==NULL) n++;
		if (t->c[i]==FULL) m++;
	}
	if (n==8) { // Sċ
		free(t);
		return NULL;
	} else if (m==8) { // Sċl܂Ă
		free(t);
		return FULL;
	}

	return t;
}

// wW̃{NZZbg(ċAp)
static OTREE* set_voxel_(OTREE *t,int x,int y,int z,int d,OTREE *p)
{
	int i;
	if (d==0) return p;
	if (t==p) return t;

	if (t==NULL || t==FULL) {
		OTREE *tmp = (OTREE*)malloc(sizeof(OTREE));
		for(i=0;i<8;i++) tmp->c[i]=t;
		t=tmp;
	}

	d--;
	i=0;
	if (x&(1<<d)) i|=1;
	if (y&(1<<d)) i|=2;
	if (z&(1<<d)) i|=4;

	t->c[i]=set_voxel_(t->c[i],x,y,z,d,p);

	return t;
}
// {NZZbg
void set_voxel(OBJECT *o,int x,int y,int z,int flag)
{
	if (x<0 || x>=FIELD_SIZE) return;
	if (y<0 || y>=FIELD_SIZE) return;
	if (z<0 || z>=FIELD_SIZE) return;
	o->octree = set_voxel_(o->octree,x,y,z,TREE_DEPTH,flag?FULL:NULL);
}

// {NZ̏Ԃ擾(ċAp)
static int get_voxel_(OTREE *t,int x,int y,int z,int d)
{
	int i;
	if (t==NULL) return 0;
	if (t==FULL) return 1;
	d--;
	i=0;
	if (x&(1<<d)) i|=1;
	if (y&(1<<d)) i|=2;
	if (z&(1<<d)) i|=4;

	return get_voxel_(t->c[i],x,y,z,d);
}
// {NZ̏Ԃ擾(0܂1)
int get_voxel(OBJECT *o,int x,int y,int z)
{
	if (x<0 || x>=FIELD_SIZE) return 0;
	if (y<0 || y>=FIELD_SIZE) return 0;
	if (z<0 || z>=FIELD_SIZE) return 0;
	return get_voxel_(o->octree,x,y,z,TREE_DEPTH);
}


// ō
void delete_sphere(OBJECT *o,int x,int y,int z,int r)
{
	int xx,yy,zz;
	for (zz=0;zz<r;zz++) {
		for (yy=0;yy<r;yy++) {
			for (xx=0;xx<r;xx++) {
				if (xx*xx+yy*yy+zz*zz<r*r) {
					set_voxel(o,x+xx,y+yy,z+zz,0);
					set_voxel(o,x-xx,y+yy,z+zz,0);
					set_voxel(o,x+xx,y-yy,z+zz,0);
					set_voxel(o,x-xx,y-yy,z+zz,0);
					set_voxel(o,x+xx,y+yy,z-zz,0);
					set_voxel(o,x-xx,y+yy,z-zz,0);
					set_voxel(o,x+xx,y-yy,z-zz,0);
					set_voxel(o,x-xx,y-yy,z-zz,0);
				}
			}
		}
	}
	o->octree = ot_opt(o->octree);
}

// tB[h\
// (炵悤ɖ@)
void ot_draw(OBJECT *o,OTREE *t,int x,int y,int z,int sz)
{
	VECTOR n;
	float l;
	if (!t) return;
	if (t==FULL) {
		/*
		glTranslatef(x+sz/2.0,y+sz/2.0,z+sz/2.0);
		glutSolidCube(sz);
		glTranslatef(-x-sz/2.0,-y-sz/2.0,-z-sz/2.0);
		*/
		int i,j;
		y+=sz;
		// 
		for (j=0;j<sz;j++) {
			for (i=0;i<sz;i++) {
				if (get_voxel(o,x+i,y,z+j)) continue;
				n.y=1.5;
				n.x=get_voxel(o,x+i-1,y,z+j)-get_voxel(o,x+i+1,y,z+j)
				 +get_voxel(o,x+i-1,y-1,z+j)-get_voxel(o,x+i+1,y-1,z+j);
				n.z=get_voxel(o,x+i,y,z+j-1)-get_voxel(o,x+i,y,z+j+1)
				 +get_voxel(o,x+i,y-1,z+j-1)-get_voxel(o,x+i,y-1,z+j+1);
				l = sqrt(n.x*n.x + n.y*n.y + n.z*n.z);
				glTranslatef((x+i)*ELEMENT_SIZE,(y)*ELEMENT_SIZE,(z+j)*ELEMENT_SIZE);
				glBegin(GL_POLYGON);
				glNormal3f(n.x/l,n.y/l,n.z/l);
				glVertex3f(0,0,0);
				glVertex3f(ELEMENT_SIZE,0,0);
				glVertex3f(ELEMENT_SIZE,0,ELEMENT_SIZE);
				glVertex3f(0,0,ELEMENT_SIZE);
				glEnd();
				glTranslatef(-(x+i)*ELEMENT_SIZE,-(y)*ELEMENT_SIZE,-(z+j)*ELEMENT_SIZE);
			}
		}
		y-=sz;

		// O
		for (j=0;j<sz;j++) {
			for (i=0;i<sz;i++) {
				if (get_voxel(o,x+i,y+j,z-1)) continue;
				n.x=get_voxel(o,x+i-1,y+j,z-1)-get_voxel(o,x+i+1,y+j,z-1)
				 +get_voxel(o,x+i-1,y+j,z)-get_voxel(o,x+i+1,y+j,z);
				n.y=get_voxel(o,x+i,y+j-1,z-1)-get_voxel(o,x+i,y+j+1,z-1)
				 +get_voxel(o,x+i,y+j-1,z)-get_voxel(o,x+i,y+j+1,z);
				n.z=-1.5;

				l = sqrt(n.x*n.x + n.y*n.y + n.z*n.z);
				glTranslatef((x+i)*ELEMENT_SIZE,(y+j)*ELEMENT_SIZE,(z)*ELEMENT_SIZE);
				glBegin(GL_POLYGON);
				glNormal3f(n.x/l,n.y/l,n.z/l);
				glVertex3f(0,0,0);
				glVertex3f(ELEMENT_SIZE,0,0);
				glVertex3f(ELEMENT_SIZE,ELEMENT_SIZE,0);
				glVertex3f(0,ELEMENT_SIZE,0);
				glEnd();
				glTranslatef(-(x+i)*ELEMENT_SIZE,-(y+j)*ELEMENT_SIZE,-(z)*ELEMENT_SIZE);
			}
		}

		z+=sz;
		// 
		for (j=0;j<sz;j++) {
			for (i=0;i<sz;i++) {
				if (get_voxel(o,x+i,y+j,z)) continue;
				n.x=get_voxel(o,x+i-1,y+j,z)-get_voxel(o,x+i+1,y+j,z)
				 +get_voxel(o,x+i-1,y+j,z-1)-get_voxel(o,x+i+1,y,z-1);
				n.y=get_voxel(o,x+i,y+j-1,z)-get_voxel(o,x+i,y+j+1,z)
				 +get_voxel(o,x+i,y+j-1,z-1)-get_voxel(o,x+i,y+j+1,z-1);
				n.z=1.5;

				l = sqrt(n.x*n.x + n.y*n.y + n.z*n.z);
				glTranslatef((x+i)*ELEMENT_SIZE,(y+j)*ELEMENT_SIZE,(z)*ELEMENT_SIZE);
				glBegin(GL_POLYGON);
				glNormal3f(n.x/l,n.y/l,n.z/l);
				glVertex3f(0,0,0);
				glVertex3f(ELEMENT_SIZE,0,0);
				glVertex3f(ELEMENT_SIZE,ELEMENT_SIZE,0);
				glVertex3f(0,ELEMENT_SIZE,0);
				glEnd();
				glTranslatef(-(x+i)*ELEMENT_SIZE,-(y+j)*ELEMENT_SIZE,-(z)*ELEMENT_SIZE);
			}
		}
		z-=sz;
		
		// 
		for (j=0;j<sz;j++) {
			for (i=0;i<sz;i++) {
				if (get_voxel(o,x-1,y+j,z+i)) continue;
				n.x=-1.5;
				n.y=get_voxel(o,x-1,y+j-1,z+i)-get_voxel(o,x-1,y+j+1,z+i)
				 +get_voxel(o,x,y+j-1,z+i)-get_voxel(o,x,y+j+1,z+i);
				n.z=get_voxel(o,x-1,y+j,z+i-1)-get_voxel(o,x-1,y+j,z+i+1)
				 +get_voxel(o,x,y+j-1,z+i)-get_voxel(o,x,y+j+1,z+i+1);

				l = sqrt(n.x*n.x + n.y*n.y + n.z*n.z);
				glTranslatef((x)*ELEMENT_SIZE,(y+j)*ELEMENT_SIZE,(z+i)*ELEMENT_SIZE);
				glBegin(GL_POLYGON);
				glNormal3f(n.x/l,n.y/l,n.z/l);
				glVertex3f(0,0,0);
				glVertex3f(0,0,ELEMENT_SIZE);
				glVertex3f(0,ELEMENT_SIZE,ELEMENT_SIZE);
				glVertex3f(0,ELEMENT_SIZE,0);
				glEnd();
				glTranslatef(-(x)*ELEMENT_SIZE,-(y+j)*ELEMENT_SIZE,-(z+i)*ELEMENT_SIZE);
			}
		}

		// E
		x+=sz;
		for (j=0;j<sz;j++) {
			for (i=0;i<sz;i++) {
				if (get_voxel(o,x,y+j,z+i)) continue;
				n.x=1.5;
				n.y=get_voxel(o,x,y+j-1,z+i)-get_voxel(o,x,y+j+1,z+i)
				 +get_voxel(o,x-1,y+j-1,z+i)-get_voxel(o,x-1,y+j+1,z+i);
				n.z=get_voxel(o,x,y+j,z+i-1)-get_voxel(o,x,y+j,z+i+1)
				 +get_voxel(o,x-1,y+j,z+i-1)-get_voxel(o,x-1,y+j,z+i+1);

				l = sqrt(n.x*n.x + n.y*n.y + n.z*n.z);
				glTranslatef((x)*ELEMENT_SIZE,(y+j)*ELEMENT_SIZE,(z+i)*ELEMENT_SIZE);
				glBegin(GL_POLYGON);
				glNormal3f(n.x/l,n.y/l,n.z/l);
				glVertex3f(0,0,0);
				glVertex3f(0,0,ELEMENT_SIZE);
				glVertex3f(0,ELEMENT_SIZE,ELEMENT_SIZE);
				glVertex3f(0,ELEMENT_SIZE,0);
				glEnd();
				glTranslatef(-(x)*ELEMENT_SIZE,-(y+j)*ELEMENT_SIZE,-(z+i)*ELEMENT_SIZE);
			}
		}
		x-=sz;
	} else {
		sz>>=1;
		ot_draw(o,t->c[0],x   ,y   ,z    ,sz);
		ot_draw(o,t->c[1],x+sz,y   ,z    ,sz);
		ot_draw(o,t->c[2],x   ,y+sz,z    ,sz);
		ot_draw(o,t->c[3],x+sz,y+sz,z    ,sz);
		ot_draw(o,t->c[4],x   ,y   ,z+sz ,sz);
		ot_draw(o,t->c[5],x+sz,y   ,z+sz ,sz);
		ot_draw(o,t->c[6],x   ,y+sz,z+sz ,sz);
		ot_draw(o,t->c[7],x+sz,y+sz,z+sz ,sz);
	}
}


/*============================ IuWFNg֌W =============================*/

// IuWFNg̃J
void free_object(OBJECT *o)
{
	int i;
	for (i=0;i<o->poly_num;i++) {
		free(o->poly[i].vertex);
	}

	if (o->type == OBJECT_OCTREE) {
		ot_free(o->octree);
		o->data = NULL;
	}

	if (o->vert) free(o->vert);
	if (o->poly) free(o->poly);
	if (o->normal) free(o->normal);
	free(o);
}

// IuWFNg̐FZbg
void set_color(OBJECT *o,float r,float g,float b)
{
	o->color[0] = r;
	o->color[1] = g;
	o->color[2] = b;
}

// IuWFNg`
void draw_object(OBJECT *o)
{
	int i,j;
	glPushMatrix();
	glColor3fv(o->color);

	if (o->type == OBJECT_RIBON) { // я̃IuWFNg
		for (i=0;i<o->vert_num/2-1;i++) {
			glBegin(GL_POLYGON);
				glNormal3fv(o->normal[i*2].v);
				glVertex3fv(o->vert[i*2].v);
				//glNormal3fv(o->normal[i*2+1].v);
				glVertex3fv(o->vert[i*2+1].v);
				glNormal3fv(o->normal[i*2+3].v);
				glVertex3fv(o->vert[i*2+3].v);
				//glNormal3fv(o->normal[i*2+2].v);
				glVertex3fv(o->vert[i*2+2].v);
			glEnd();
		}
	} else if (o->type == OBJECT_OCTREE) { // tB[hf[^
		ot_draw(o,o->octree,0,0,0,FIELD_SIZE);
	} else if (o->type == OBJECT_SQUARES) { // lp`̏W
		for (i=0;i<o->vert_num/4;i++) {
			glBegin(GL_POLYGON);
				glNormal3fv(o->normal[i].v);
				glVertex3fv(o->vert[i*4  ].v);
				glVertex3fv(o->vert[i*4+1].v);
				glVertex3fv(o->vert[i*4+2].v);
				glVertex3fv(o->vert[i*4+3].v);
			glEnd();
		}
	} else { // |S̏W
		for (i=0;i<o->poly_num;i++) { // SẴ|S
			glBegin(GL_POLYGON);
			glNormal3fv(o->poly[i].normal_v);
			for(j=0;j<o->poly[i].vert_num;j++) // SĂ̒_
				glVertex3fv((float*)&o->vert[o->poly[i].vertex[j]]);
			glEnd();
		}
	}

	glPopMatrix();
}

// rbg}bvtB[hǂݍ
OBJECT *load_field(char *bmp)
{
	OBJECT *o;
	char buf[128];
	unsigned char field[FIELD_SIZE*FIELD_SIZE];
	int x,y;
	FILE *fp = fopen(bmp,"rb");
	fread(buf,1,0x36,fp); // skip header
	if (buf[0]!='B') {
		fclose(fp);
		return NULL;
	}

	for(y=0;y<FIELD_SIZE;y++) {
		for(x=0;x<FIELD_SIZE;x++) {
			fread(buf,1,3,fp); // read BGR
			field[y*FIELD_SIZE+x]=buf[0]&0xff; // Blue
		}
	}
	fclose(fp);

	o = (OBJECT*)malloc(sizeof(OBJECT));

	o->type = OBJECT_OCTREE;
	o->shade = 1;
	o->vert_num = 0;
	o->vert = NULL;
	o->poly_num = 0;
	o->poly = NULL;
	o->normal = NULL;
	o->octree = ot_make(0,0,0,FIELD_SIZE,field);
	set_color(o,0.2,1.0,0.1);

	glDeleteLists(1,1);
	glNewList(1,GL_COMPILE);
	draw_object(o);
	glEndList();

	return o;
}


// ~IuWFNg쐬
// r	a
// p1	ʂZW
// p2	ʂZW
OBJECT *make_cylinder(float r,float p1,float p2)
{
	int n = 36; // p
	OBJECT *obj=(OBJECT*)malloc(sizeof(OBJECT));
	obj->color[0] = 1.0f;
	obj->color[1] = 1.0f;
	obj->color[2] = 1.0f;

	obj->type = OBJECT_RIBON;
	obj->shade = 1;

	obj->vert_num = (n+1)*2;
	obj->vert = (POSITION*)malloc(sizeof(POSITION)*obj->vert_num);
	obj->normal = (VECTOR*)malloc(sizeof(VECTOR)*obj->vert_num);
	obj->poly_num = 0;
	obj->poly = NULL;

	int i;
	for (i=0;i<n;i++) {
		obj->normal[i*2].x = cos(i*2*3.14159f / n);
		obj->normal[i*2].y = sin(i*2*3.14159f / n);
		obj->normal[i*2].z = 0;
		obj->vert[i*2].x = obj->normal[i*2].x*r;
		obj->vert[i*2].y = obj->normal[i*2].y*r;
		obj->vert[i*2].z = p1;

		obj->normal[i*2+1] = obj->normal[i*2];
		obj->vert[i*2+1] = obj->vert[i*2];
		obj->vert[i*2+1].z = p2;
	}

	obj->normal[n*2] = obj->normal[0];
	obj->normal[n*2+1] = obj->normal[1];
	obj->vert[n*2] = obj->vert[0];
	obj->vert[n*2+1] = obj->vert[1];

	return obj;
}


/*============================ Q[ ===============================*/

GLuint texture[TEXTURES]; // eNX`

int turn = 0; // ^[
int state = 256; //  (256:^Cg 2: 3:͑҂ 4:evZc )
int cnt=0; // JE^
int now_player; // Jgv[


// tB[h
OBJECT *field;

// _
POSITION pos = {-4,-2,-15};
float rot_y=0;
float rot2=0;

// ev[[
typedef struct {
	POSITION pos; // ʒu
	float deg; // p
	float degy;  // 
	OBJECT *turret; // C
	int rot1,rot2; // _
} PLAYER;

PLAYER player[PLAYERS];

// Ce
POSITION mp; // ʒu
VECTOR mv; // x

// 
int wind_v=0; // 
int wind_d; // 


// \
void display(void)
{
	int i;
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	glPushMatrix();

	glTranslatef(pos.x, pos.y, pos.z);
	glTranslatef(FIELD_SIZE*ELEMENT_SIZE/2,0, FIELD_SIZE*ELEMENT_SIZE/2);
	glRotatef(rot2, 1.0, 0.0, 0.0);
	glRotatef(rot_y, 0.0, 1.0, 0.0);
	glTranslatef(-FIELD_SIZE*ELEMENT_SIZE/2,0, -FIELD_SIZE*ELEMENT_SIZE/2);

	// tB[h
	//draw_object(field);
	glCallList(1);

	// 
	glColor3f(0.0f, 0.3f, 1.0f);
	glBegin(GL_POLYGON);
		glNormal3f(0.0, 1.0, 0.0);
		glVertex3f(0.0, 0.0, 0.0);
		glVertex3f(SIZE, 0.0, 0.0);
		glVertex3f(SIZE, 0.0, SIZE);
		glVertex3f(0.0, 0.0, SIZE);
	glEnd();

	// C
	for (i=0;i<PLAYERS;i++) {
		glPushMatrix();
			glColor3f(1.0f, 1.0f, 1.0f);
			glTranslatef(player[i].pos.x*ELEMENT_SIZE,player[i].pos.y*ELEMENT_SIZE,player[i].pos.z*ELEMENT_SIZE);
			glutSolidSphere(0.3,8,8);
			glTranslatef(0.0,0.2,0.0);
			glRotatef(player[i].degy, 0.0, 1.0, 0.0);
			glRotatef(-player[i].deg, 1.0, 0, 0.0);
			draw_object(player[i].turret);
		glPopMatrix();
	}

	if (state==3) {
		// Ce
		glColor3f(1.0f, 1.0f, 1.0f);
		glTranslatef(mp.x*ELEMENT_SIZE, mp.y*ELEMENT_SIZE, mp.z*ELEMENT_SIZE);
		glutSolidSphere(0.1,8,8);
	}else if (state==4) {
		// 
		glColor3f(1.0f, 0.1f, 0.0f);
		glTranslatef(mp.x*ELEMENT_SIZE, mp.y*ELEMENT_SIZE, mp.z*ELEMENT_SIZE);
		glutSolidSphere(cnt*ELEMENT_SIZE/2,20,20);
	}

	glPopMatrix();

	// \
	if (wind_v) {
		glPushMatrix();
			glTranslatef(1.0,0.9,-2.0);
			glRotatef(40, 1.0, 0.0, 0.0);
			glRotatef(rot_y, 0.0, 1.0, 0.0);
			glRotatef(wind_d, 0.0, 1.0, 0.0);
			glColor3f(1.0f, 1.0f, 0.0f);
			// Z̖
			glScalef(1.0,1.0,wind_d*0.01);
			glBegin(GL_POLYGON);
				glNormal3f(0.0, 1.0, 0.0);
				glVertex3f(-0.05, 0.0, 0.0);
				glVertex3f(-0.05, 0.0, 0.2);
				glVertex3f(0.05, 0.0, 0.2);
				glVertex3f(0.05, 0.0, 0.0);
			glEnd();
			glBegin(GL_POLYGON);
				glNormal3f(0.0, 1.0, 0.0);
				glVertex3f(-0.1, 0.0, 0.2);
				glVertex3f(0.1, 0.0, 0.2);
				glVertex3f(0.0, 0.0, 0.3);
			glEnd();
		glPopMatrix();
	}

	// rbg}bv
	if (state&0x100) {
		glTranslatef(0.0, 0.0, -2.0);
		if (state==0x100) {
			glTranslatef(0.0, 0.0, -cnt*0.5);
			glRotatef(10*cnt, 0.0, 1.0, 0.0);
		}
		if (state==0x100 || cnt>10) {
			glEnable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D , texture[state&0xff]);
			glColor3f(1.0f, 1.0f, 1.0f);
			glBegin(GL_POLYGON);
				glNormal3f(0.0, 0.0, 1.0);
				glTexCoord2f(1.0, 0.0); glVertex3f(1.2, 1.0, 0.0);
				glTexCoord2f(0.0, 0.0); glVertex3f(-1.2, 1.0, 0.0);
				glTexCoord2f(0.0, 1.0); glVertex3f(-1.2, -1.0, 0.0);
				glTexCoord2f(1.0, 1.0); glVertex3f(1.2, -1.0, 0.0);
			glEnd();
			glDisable(GL_TEXTURE_2D);
		}
	}

	glutSwapBuffers();
}

void reshape(int w, int h)
{
	glViewport(0, 0, (GLsizei)w, (GLsizei)h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(60.0, (GLfloat)w/(GLfloat)h, 0.02, 20.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}


void timer(int value) {
	int i;
	float d;

	// pxǏ]
	if (rot_y!=player[now_player].rot2) {
		d=player[now_player].rot2-rot_y;
		if (d>180) d-=360;
		if (d<-180) d+=360;
		if (d>5) {
			d=d/4+3;
		}
		if (d<-5) {
			d=d/4-3;
		}
		rot_y+=d;
	}
	if (rot2!=player[now_player].rot1) {
		d=player[now_player].rot1-rot2;
		if (d>180) d-=360;
		if (d<-180) d+=360;
		if (d>5) {
			d=d/4+3;
		}
		if (d<-5) {
			d=d/4-3;
		}
		rot2+=d;
	}

	// ԂɂĐU蕪
	if (state==0x100) { // Title
		if (cnt && ++cnt>9) {
			state=1;
			// Q[
			now_player = 0;
			turn=1;
		}
	} else if (state==1) { // init turn
		// ݒ
		wind_d=45+(rand()%2)*180;
		wind_v=rand()%8;
		state=2;
	} else if (state==2) { // ready
		player[now_player].deg+=4;
		if (player[now_player].deg>90) player[now_player].deg=0;
	} else if (state==3) { // flying
		VECTOR wind;
		mp.x+=mv.x;
		mp.y+=mv.y;
		mp.z+=mv.z;

		// d
		mv.y-=0.1;

		// CR(Ȉ)
		wind.x = wind_v * sin(wind_d*3.14159/180);
		wind.z = wind_v * cos(wind_d*3.14159/180);
		wind.y = 0;
		//mv.x+=(wind.x-mv.x)*(wind.x-mv.x)*wind.x*0.001;
		mv.x+=(wind.x-mv.x)*0.005;
		mv.y+=(wind.y-mv.y)*0.005;
		mv.z+=(wind.z-mv.z)*0.005;

		if (mp.y<0) {
			state=5;
		}

		if (get_voxel(field,(int)mp.x,(int)mp.y,(int)mp.z)) {
			state=4;
			cnt=0;
		}
	} else if (state==4) { // e
		cnt++;
		if (cnt>turn+3) {
			int r=turn/2+2;
			state=5;

			delete_sphere(field,(int)mp.x,(int)mp.y,(int)mp.z,r);
			for (i=0;i<PLAYERS;i++) {
				if ( (mp.x-player[i].pos.x)*(mp.x-player[i].pos.x)
					+(mp.y-player[i].pos.y)*(mp.y-player[i].pos.y)
					+(mp.z-player[i].pos.z)*(mp.z-player[i].pos.z) <= r*r ) {
					state=256+PLAYERS-i;
					cnt=0;
				}
			}
			glDeleteLists(1,1);
			glNewList(1,GL_COMPILE);
			draw_object(field);
			glEndList();
		}
	} else if (state==5) { // ̃v[
			now_player++;
			if (now_player>=PLAYERS) {
				turn++;
				now_player = 0;
			}
			state=1;
	} else if (state>0x100) { // s
		if (++cnt>50) {
			char fname[256];
			sprintf(fname,"field%02d.bmp",(rand()%FIELDS)+1);
			free_object(field);
			field=load_field(fname);
			turn=1;
			state=256;
		}
	}
	glutPostRedisplay();
	glutTimerFunc(50 , timer , 0);
}

void specialkey(int key, int x, int y){
	int m=glutGetModifiers();
	if (state==0x100) cnt++;
	switch(key) {
		case GLUT_KEY_UP : // 
			player[now_player].rot1+=5;
			player[now_player].rot1%=360;
		break;
		case GLUT_KEY_DOWN : // 
			player[now_player].rot1-=5;
			player[now_player].rot1%=360;
		break;
		case GLUT_KEY_LEFT : // ]
			if (m&GLUT_ACTIVE_SHIFT)
				player[now_player].degy+=5;
			else
				player[now_player].rot2+=5;
			player[now_player].rot2%=360;
		break;
		case GLUT_KEY_RIGHT : // E]
			if (m&GLUT_ACTIVE_SHIFT)
				player[now_player].degy-=5;
			else
				player[now_player].rot2-=5;
			player[now_player].rot2%=360;
		break;
		case GLUT_KEY_PAGE_UP : // Y[C
			pos.z+=MV;
		break;
		case GLUT_KEY_PAGE_DOWN : // Y[AEg
			pos.z-=MV;
		break;
	}
}

void keyboard(unsigned char key, int x, int y)
{
	if (state==0x100) cnt++;

	switch(key) {
	case 'z' : // O
		pos.z+=MV;
		break;
	case 'x' : // 
		pos.z-=MV;
		break;
	case 'a' : // Ɉړ
		pos.x-=MV;
		break;
	case 'd' : // EɈړ
		pos.x+=MV;
		break;
	case 's' : // Ɉړ
		pos.y-=MV;
		break;
	case 'w' : // Ɉړ
		pos.y+=MV;
		break;

	case ' ' : // 
		if (state==2) {
			mv.x=cos(player[now_player].deg*2*3.14159/360)*2.8*sin(player[now_player].degy*2*3.14159/360);
			mv.y=sin(player[now_player].deg*2*3.14159/360)*2.8;
			mv.z=cos(player[now_player].deg*2*3.14159/360)*2.8*cos(player[now_player].degy*2*3.14159/360);
			mp.x=player[now_player].pos.x + mv.x/2;
			mp.y=player[now_player].pos.y + mv.y/2+1;
			mp.z=player[now_player].pos.z + mv.z/2;
			state=3;
		}
		break;
	
	case 'q' : // I
		exit(1);
	}
	rand(); // 
	glutPostRedisplay();
}

// eNX`prbg}bvǂݍ
char *load_bitmap(char *fname)
{
	int head[16];
	int x,y,w,h;
	char bgr[3];

	FILE *fp = fopen(fname,"rb");
	fread(head,1,2,fp); // signature
	if (memcmp(head,"BM",2)) {
		fclose(fp);
		return NULL;
	}
	fread(head,1,0x34,fp); // header
	w=head[4];
	h=head[5];

	char *buf = (char*)malloc(w*h*3);
	
	for(y=h-1;y>=0;y--) {
		for(x=0;x<w;x++) {
			fread(bgr,1,3,fp); // read BGR
			buf[(y*h+x)*3  ] = bgr[2];
			buf[(y*h+x)*3+1] = bgr[1];
			buf[(y*h+x)*3+2] = bgr[0];
		}
	}
	fclose(fp);
	return buf;
}

void init(void)
{
	int i;
	GLfloat light_position[] = {-1.0, 1.0, 1.0, 0.0};
	GLfloat light_diffuse[] = {1.0, 1.0, 1.0, 1.0};

	glClearColor(0.0, 1.0, 1.0, 0.0);

	glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
	glLightfv(GL_LIGHT0, GL_POSITION, light_position);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);

	glColorMaterial(GL_FRONT, GL_DIFFUSE);
	glEnable(GL_COLOR_MATERIAL);

	glEnable(GL_DEPTH_TEST);

	// eNX`
	glGenTextures(TEXTURES , texture);
	for (i=0;i<TEXTURES;i++) {
		char fname[16];
		sprintf(fname,"texture%02d.bmp",i+1);
		char *bitmap=load_bitmap(fname);
		if (bitmap) {
			glBindTexture(GL_TEXTURE_2D , texture[i]);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
			glTexImage2D(
				GL_TEXTURE_2D , 0 , GL_RGB , TEXSIZE , TEXSIZE ,
				0 , GL_RGB , GL_UNSIGNED_BYTE , bitmap);
			// printf("texture title.bmp %d ok.\n",texture[0]);
		}
	}
}


int main (int argc,char **argv)
{
	char fname[256];
	srand(time(NULL));

	// OpenGL 
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutInitWindowSize(640, 480);
	glutInitWindowPosition(100, 100);
	glutCreateWindow("toride v1");
	init();
	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutKeyboardFunc(keyboard);
	glutSpecialFunc(specialkey);

	// v[
	player[0].turret = make_cylinder(0.05,0.1,0.5); // C̃IuWFNg
	player[0].deg= 45;
	player[0].degy= 45;
	player[0].pos.x= 2;
	player[0].pos.y= 2;
	player[0].pos.z= 2;
	player[0].rot1=20;
	player[0].rot2=180;
	set_color(player[0].turret,1.0,0.0,0.0);

	player[1].turret = make_cylinder(0.05,0.1,0.5);
	player[1].deg= 45;
	player[1].degy= 45+180;
	player[1].pos.x= FIELD_SIZE-3;
	player[1].pos.y= 2;
	player[1].pos.z= FIELD_SIZE-3;
	player[1].rot1=20;
	player[1].rot2=0;
	set_color(player[1].turret,0.0,0.0,1.0);

	// tB[hǂݍ
	if (argc>1) {
		strcpy(fname, argv[1]);
	} else {
		sprintf(fname,"field%02d.bmp",(rand()%FIELDS)+1);
	}
	field=load_field(fname);
	if (!field) {
		fprintf(stderr,"%s : fail to load\n",argv[0]);
		exit(1);
	}

	// ^C}[
	glutTimerFunc(100 , timer , 0);

	glutMainLoop();

	// IuWFNg̃̈J
	free_object(player[0].turret);
	free_object(player[1].turret);
	free_object(field);

	return 0;
}

